' Jasc Soccer Just Another Sensi Clone - a try to make a sensi clone by Pitto

'TODO LIST ##############################################################################
' MATCH EVENTS
' HEADKICKS routine
' draw other sprites
' cleanup code (heavy work!) <-------- :(
' better ball physics
' pl acceleration delta - not immediately can reach top speed
' IMPROVE AI (sooo much!)
' improve the "get_passing_ball_speed" function
' matchtime and half-time field switch
' Human vs Pc
' replay
' change team color by pset function
' FPS limit
' custom font
' dedicated AI for the GK - jump, hold the ball
' GAME MENU
'########################################################################################

' a must
#Include "fbgfx.bi"

'this is the language I use
Using FB

'oh yea, I like random numbers, They're so useful and funny! :)
Randomize Timer()

#define GAME_NAME "JASC SOCCER"
#define GAME_VERSION "0.18"
#define GAME_AUTHOR "Pitto"

'pitch dimensions - no change x and y, please, or the gk may get crazy :O
#define PITCH_X 50
#define PITCH_Y 50
'***PLEASE, use a 32 multiplier, so the pitch texture may fit better! :)
#define PITCH_W 1024
#define PITCH_H 608
#define PITCH_PENALTY_AREA PITCH_H*0.30
#define PITCH_NET_W 100
#define PITCH_NET_H 25

#define PITCH_MIDDLE_W PITCH_W\2 + PITCH_X
#define PITCH_MIDDLE_H PITCH_H\2 + PITCH_Y

'net positions
#define PITCH_NET_RX_CENTER PITCH_W+PITCH_X
#define PITCH_NET_RY_CENTER PITCH_H\2+PITCH_Y
#define PITCH_NET_LX_CENTER PITCH_X
#define PITCH_NET_LY_CENTER PITCH_H\2+PITCH_Y

'tiles on the pitch *NO CHANGE THIS VALUE PLEASE!*** JASC MAY CRASH :(
#define TILES_N_TOT 35
#define COL_TOT_N 6
#define ROW_TOT_N 6

'players for each team *SAME AS ABOVE* :(
#define N_TOT_PL 11

'gravity acceleration
#define GRAVITY_ACCEL 9.8f
'friction of the ball bouncing on the pitch
#define BOUNCE_FRICTION 0.85f
'friction of the air
#define AIR_FRICTION 0.98f
'friction of the pitch
#define FRICTION 0.90f
'default speed of the players
#define PL_DEFAULT_SPEED 1.3f
'screen width and height
#define SCREEN_W 800
#define SCREEN_H 500
'useful to don't allow the camera to move everywere, this sets a limit
#define CAMERA_PADDING 45
'maximum speed the ball can reach so it doesn't become a ball flame
#define BALL_MAX_SPEED 20

'minimum speed of the ball
#define BALL_MIN_SPEED 0.5f

'delay of the player before executing another action
#define PL_DELAY_TIME 50

#define PL_DELAY_FALLING 10
#define PL_DELAY_FALLED 20
'minimum distance between two players - see check_pl_collisions sub for details
#define PL_MIN_DIST 10
'minimum distance from opponent pl to allow pl owner of the ball to run to the net
#define PL_RUN_SPACE 80

'lenght in ms of the sleep statement
#define SLEEP_TIME 25

'colors
#define COLOR_BLACK &h000000
#define COLOR_WHITE &hFFFFFF
#define COLOR_GRAY &h7F7F7F
#define COLOR_RED &hFF0000
#define COLOR_BLUE &h0000FF
#define COLOR_GREEN &h00FF00
#define COLOR_YELLOW &hFFFF00
#define COLOR_CYAN &h00FFFF
#define COLOR_LILIAC &h7F00FFs
#define COLOR_ORANGE &hFF7F00
#define COLOR_PURPLE &h7F007F
#define COLOR_DARK_RED &h7F0000
#define COLOR_DARK_GREEN &h007F00
#define COLOR_DARK_BLUE &h00007F

'kit predefined colors
#define COLOR_KIT_HAIR RGB(23,23,23)
#define COLOR_KIT_SHIRT RGB(0,0,127)
#define COLOR_KIT_PANTS RGB(127,127,255)
#define COLOR_KIT_SHOES RGB(63,63,63)
#define COLOR_KIT_LINE RGB(43,154,209)
#define COLOR_KIT_SKIN RGB(255,125,20)

'total number of the player sprites
#define PL_SPRITES_TOT_N 112

'PI----------------------------------------------------------------------------------
#Define PI 3.14159265f
#define PI2 PI/2
#define PI4 PI/4
#define PI1_5 PI*1.5f
#define PI_2 PI*2f

#define GRAVITY 0.980665f

'TYPES
Type camera_proto
  Dim x As Single
  Dim y As Single
  Dim w As Single
  Dim h As Single
  Dim speed As Single
  Dim rds As Single
End Type

Type player_proto
  Dim id As Integer       'unique id of the player 0-N_TOT_PL*2
  Dim team As Integer     ' 0  for home team - 1 for away team
  Dim number As Integer   'number of the player
  Dim label As String * 32 'name of the player    *out of order
  Dim old_x As Single 'old x position
  Dim old_y As Single 'old y position
  Dim x As Single         'x position
  Dim y As Single         'y position
  Dim z As Single         'z position
  Dim rds As Single       'rotation of the player (in radiants (0-6.28))
  Dim tact_offset_x As Integer 'offset x to the tactic
  Dim tact_offset_y As Integer 'offset y to the tactic
  Dim speed_default As Single     'speed defualt of the player
  Dim speed As Single     'speed of the player
  Dim speed_max As Single 'maximum speed that the player can reach
  Dim accel As Single     'acceleration delta    *out of order
  Dim frame As Integer    'useful to get the correct sprite frame
  Dim frame_offset As Integer 'useful to get the correct sprite frame
  Dim dist As Single  'distance covered by the pl
  Dim w As Integer        'width
  Dim ball_radius As Integer 'maximum distance to get the ball    *out of order
  Dim active As Integer ' check if the player is ready to make an action
  'ACTION: 0 none; 1 Running; 2 Jumping; 3 Sliding; 4 Falling; 5 Falled
  Dim action As Integer
  Dim delay As Integer ' how many cycles delays the player to perform  an action
End Type

Type ball_proto
  Dim x As Single         'x position
  Dim y As Single         'y position
  Dim z As Single         'z position
  Dim old_x As Single
  Dim old_y As Single
  Dim z_speed As Single       'z accel ratio
  Dim z_speed_init As Single   'z accel ratio
  Dim speed As Single     'speed
  Dim w As Integer  'width
  Dim rds As Single 'rotation
  Dim effect As Single 'effect
  Dim frame As Integer 'which frame
End Type

'SHARED VARIABLES----------------------------------------------------------------------------
Dim Shared DEBUG As Integer = 0

Dim Shared goal_team_0 As Integer = 0
Dim Shared goal_team_1 As Integer = 0

Dim Shared tct_tile(0 To 9, 0 To 35) As Integer 'tactic array
'it indicates in wich `a` tile the pl must go if the ball is in `b` tile
'for example: ball in tile 20, pl must go to tile 12
'see also functions `get_tact_tile`, `get_rds_from_tile`,
'`get_dist_from_tile` and `get_ball_tile`
'and sub `load_tact`

Dim Shared bhv_tile(0 To 35, 0 To 9) As Integer 'behavior array
'it gives a percentage table for the behavior of the players owners of the ball
'see relative sub for details

Dim Shared pl_sprites_action(0 To 5, 0 To 1) As Integer 'sprites for pl.action

'it represents (action, (Lbound of sprites, Ubound of sprites))Lbound & Ubound of the sprites
Dim Shared pl_sprite_0(PL_SPRITES_TOT_N) As Any Ptr ' A pointer that points to a memory buffer (for plrs sprites)
Dim Shared pl_sprite_1(PL_SPRITES_TOT_N) As Any Ptr ' A pointer that points to a memory buffer (for plrs sprites)
Dim Shared ball_sprite(15) As Any Ptr '  A pointer that points to a memory buffer (for ball sprites)
Dim Shared net_sprite(2) As Any Ptr '  A pointer that points to a memory buffer (for net sprites)
Dim Shared pitch_sprite(2) As Any Ptr '  A pointer that points to a memory buffer (for pitch sprites)
Dim Shared banner_sprite As Any Ptr 'idem for banner
Dim Shared shadowed_sprite As Any Ptr 'idem for shadowed sprite

Dim Shared workpage As Integer ' buffer holding the player sprites
Dim Shared addframe As Integer = 0 'to be soon removed

Dim Shared c_x_o As Single = 0 'camera x offset
Dim Shared c_y_o As Single = 0 'camera y offset

Dim Shared camera As camera_proto 'camera type
Dim Shared pl(N_TOT_PL*2) As player_proto 'player type
Dim Shared ball As ball_proto 'ball type

Dim Shared PL_target_id As Integer = -1 '-1: none; 0-etc. indicates the id of the pl that's receiving pass
Dim Shared PL_ball_owner_id As Integer = -1 '-1: none; 0-etc. indicates the id of the pl owning the ball
Dim Shared PL_ball_owner_delay As Integer = PL_DELAY_TIME*2 'for how much time owning the ball after the touch
Dim Shared PL_team_owner_id As Integer = -1 'indicates the id of the team owning the ball

Dim Shared SHELL_message As String * 64 'this is useful for debug, to store and display shell-like messages

Dim Shared MATCH_event As Integer = -1 'indicates the actual match event
' -1 none; 0   ; 1 in action; 2 ball off upper side; 3 ball off lower side
' 4 ball off left side; 5 ball off right side; 6 freekick; 7 penalty


'USEFUL VARIABLES----------------------------------------------------------------------------
Dim count As Integer = 0

'init camera dimensions
camera.w = SCREEN_W
camera.h = SCREEN_H
camera.x = PITCH_MIDDLE_W
camera.y = PITCH_MIDDLE_H

' FUNCTIONS DECLARATIONS---------------------------------------------------------------------
'converts radiants to degree
Declare Function r_t_d (degree As Integer) As Integer
' converts degree to radiants
Declare Function d_t_r (degree As Integer) As Single
' calculates the angle between two points
Declare Function a_b_t_p (x1 As Single, y1 As Single, x2 As Single, y2 As Single) As Single
' calculates the distance between two points
Declare Function d_b_t_p (x1 As Single, y1 As Single, x2 As Single, y2 As Single) As Single
' calculates the starting frame for the player sprite from the angle in radiants
Declare Function start_frame (radiants As Single) As Integer
' calculates in wich pitch tile the player must go (use it if the player hasn't the ball possession)
Declare Function get_tact_tile (pl_id As Integer) As Integer
' returns in wich tile is the ball
Declare Function get_ball_tile(team As Integer) As Integer
' calculate the radiants to get the right tile
Declare Function get_rds_from_tile(tile As Integer, pl_x As Single, pl_y As Single) As Single
' calculate the distance between player and the tile where he must go
Declare Function get_dist_from_tile(tile As Integer, pl_x As Single, pl_y As Single) As Single
' return the nearest player to the ball
Declare Function get_nrst_pl_ball(n_team As Integer) As Integer
' giving the id of the team returns the nearest player to pass the ball
Declare Function get_nrst_pl_pass(pl_id As Integer) As Integer
' giving the id of the team returns the 2nd nearest player to pass the ball
Declare Function get_nrst2_pl_pass(pl_id As Integer, order As Integer) As Integer
' giving the unique id of the player calculate wich is his team
' and return the farrest player to pass the ball
Declare Function get_farrest_pl_to_pass(pl_id As Integer) As Integer    '*out of order
' giving the unique id of the player calculate wich is his team and
'return the player nearest to the corner line
Declare Function get_endline_pl_to_pass(pl_id As Integer) As Integer
' giving the unique id of the player calculate wich is his team and
'return the player nearest to middlefield
Declare Function get_centerest_pl_to_pass(pl_id As Integer) As Integer
' giving the unique id of the player owner of the ball
' calculate wich is his team and returns the right player to pass by longside
Declare Function get_longside_pl_to_pass (pl_id As Integer) As Integer
' giving the unique id of the player owner of the ball
' calculate wich is his team and returns the right player to pass by shortside
Declare Function get_shortside_pl_to_pass (pl_id As Integer) As Integer
'giving the distance between pl an pl to pass returns the correct speed of the ball
Declare Function get_passing_ball_speed (dist As Single) As Single
'this function returns 1 if the object is into the camera crop - useful to use less CPU timing for
'drawing functions
Declare Function is_in_camera_crop (x As Single, y As Single, diam As Integer) As Integer


'SUBS DECLARATIONS-----------------------------------------------------------------------
'load fonts
Declare Sub load_fonts()
'load tactics
Declare Sub load_tact()
'load behavior of the player owner of the ball
Declare Sub load_behavior()
'gest keyboard events
Declare Sub get_user_input()
'load sprites
Declare Sub load_bitmap()
'paints the kits of the teams with a custom color
Declare Sub paint_kits(color_shirt_0 As UInteger, color_pants_0 As UInteger,_
color_shirt_1 As UInteger, color_pants_1 As UInteger)
'delete the sprites
Declare Sub delete_bitmap()
'draws the nets
Declare Sub draw_nets()
'draws the pitch
Declare Sub draw_pitch()
'update the ball
Declare Sub update_ball()
'draw the grid
Declare Sub draw_grid()
'draws the players
Declare Sub draw_players()
'resets the position of the players (0's ids on the left side, 1's ids on the right side)
Declare Sub reset_players_positions()
'puts the ball into the centre of the pitch
Declare Sub ball_put_on_centre()
' update the beahovior of the players
Declare Sub update_players()
' checks if the ball gest the limits of the pitch
' or if the ball goes into any net
Declare Sub ball_border_pitch_limit_check()
'updates the position of the camera following the ball with easing effect
Declare Sub camera_update_position()
'initialize the players proprietes
Declare Sub init_players_proprietes()
'sets to 0 axis z of the ball and z_Speed of the ball
Declare Sub reset_ball_z()
'draws the ball
Declare Sub draw_ball()
'giving the id of the player who owns the ball, calculate in wich tile is,
'it manages the player behavior (for example: running to the net, passing, shooting, etc...)
Declare Sub get_pl_behavior(pl_id As Integer)
'cheks if two or more players collide
Declare Sub check_pl_collisions()
'draws the bottom infos
Declare Sub draw_bottom_info()

Sub load_fonts()
  '    draw string
End Sub


Sub load_bitmap()
  Dim As Integer img_x, img_w, img_y, img_h, count, action

  'initializing pl_sprites_action array - see definition fot details
  '    For action = 0 To 2
  '        Read pl_sprites_action(action, 0)
  '        Read pl_sprites_action(action, 1)
  '    Next action

  'loading pl sprites
  img_w = 21
  img_h = 25
  img_x = 0
  img_y = 0
  'load and stores the sprites into two array
  'one array for each team then with paint_kits sub
  'the color of the kits of the sprites will be changed
  BLoad "img\pl_sprites.bmp", 0
  For count = 0 To PL_SPRITES_TOT_N-1
    If (count > 0) And (count Mod 14 = 0) Then
      img_x = 0
      img_y += img_h
    End If
    pl_sprite_0(count) = ImageCreate (img_w, img_h)
    pl_sprite_1(count) = ImageCreate (img_w, img_h)
    Get (img_x, img_y)-(img_x + 20, img_y + 24), pl_sprite_0(count)
    Get (img_x, img_y)-(img_x + 20, img_y + 24), pl_sprite_1(count)
    img_x += img_w
  Next count

  'loading ball sprites
  BLoad "img\ball_sprites.bmp", 0
  img_x = 0
  img_y = 0
  For count = 0 To 14
    ball_sprite(count) = ImageCreate (img_w, img_h)
    Get (img_x, img_y)-(img_x + 15, img_y + 15), ball_sprite(count)
    img_x += 16
  Next count

  'loading net sprites
  BLoad "img\net_0.bmp",0
  net_sprite(0) = ImageCreate(50,125)
  Get (0,0)-(49,124), net_sprite(0)
  BLoad "img\net_1.bmp",0
  net_sprite(1) = ImageCreate(50,125)
  Get (0,0)-(49,124), net_sprite(1)

  'loading pitch grass
  BLoad "img\pitch.bmp",0
  pitch_sprite(0) = ImageCreate(32,32)
  Get (0,0)-(31,31), pitch_sprite(0)
  pitch_sprite(1) = ImageCreate(32,32)
  Get (32,0)-(63,31), pitch_sprite(1)

  'loading advertising banner
  BLoad "img\banner.bmp",0
  banner_sprite = ImageCreate(256,24)
  Get (0,0)-(255,23), banner_sprite

  'loading the shadowet texture
  BLoad "img\shadowed.bmp",0
  shadowed_sprite = ImageCreate(32,32)
  Get (0,0)-(31,31), shadowed_sprite

End Sub

Sub paint_kits(color_shirt_0 As UInteger, color_pants_0 As UInteger,_
  color_shirt_1 As UInteger, color_pants_1 As UInteger)

  Dim As Integer pitch, count, img_w = 0, img_h = 0
  Dim pixels As Any Ptr

  For count = 0 To PL_SPRITES_TOT_N - 1
    If 0 <> ImageInfo( pl_sprite_0(count),img_w ,img_h,, pitch, pixels ) Then
      Print "unable to retrieve image information."
      Sleep
      End
    End If
    'Paint the sprite white the selected color image by directly manipulating pixel memory.
    For y As Integer = 0 To img_h
      Dim row As UInteger Ptr = pixels + y * pitch

      For x As Integer = 0 To img_w
        If row[x] = COLOR_KIT_SHIRT Then
          row[x] = color_shirt_0
        End If
        If row[x] = COLOR_KIT_PANTS Then
          row[x] = color_pants_0
        End If
        If row[x]= COLOR_KIT_LINE Then
          row[x] = color_pants_0
        End If
      Next x
    Next y
    If 0 <> ImageInfo( pl_sprite_1(count),img_w ,img_h,, pitch, pixels ) Then
      Print "unable to retrieve image information."
      Sleep
      End
    End If
    'Paint the sprite white the selected color image by directly manipulating pixel memory.
    For y As Integer = 0 To img_h
      Dim row As UInteger Ptr = pixels + y * pitch

      For x As Integer = 0 To img_w
        If row[x] = COLOR_KIT_SHIRT Then
          row[x] = color_shirt_1
        End If
        If row[x] = COLOR_KIT_PANTS Then
          row[x] = color_pants_1
        End If
        If row[x]= COLOR_KIT_LINE Then
          row[x] = color_pants_1
        End If
      Next x
    Next y
  Next count

End Sub


Sub delete_bitmap()
  Dim count As Integer
  For count = 0 To PL_SPRITES_TOT_N
    If pl_sprite_0(count) Then ImageDestroy pl_sprite_0(count)
    If pl_sprite_1(count) Then ImageDestroy pl_sprite_1(count)
  Next
  For count = 0 To 14
    If ball_sprite(count) Then ImageDestroy ball_sprite(count)
  Next
  If net_sprite(0)   Then ImageDestroy net_sprite(0)
  If net_sprite(1)   Then ImageDestroy net_sprite(1)
  If pitch_sprite(0) Then ImageDestroy pitch_sprite(0)
  If pitch_sprite(1) Then ImageDestroy pitch_sprite(1)
  If banner_sprite   Then ImageDestroy banner_sprite
  If shadowed_sprite Then ImageDestroy shadowed_sprite
End Sub

'DATA 0,0        '0
'DATA 0,5        '1
'DATA 6,11       '2
'DATA 6,11       '3
'DATA 6,11       '4
'
Sub draw_pitch()
  Dim As Integer pitch_rows, pitch_cols, a, b
  Dim banner_message As String*32
  pitch_rows = pitch_w \ 32
  pitch_cols = pitch_h \ 32

  Paint (SCREEN_W\2,SCREEN_H\2), COLOR_DARK_GREEN

  'banner
  Put (PITCH_MIDDLE_W - c_x_o - 128, PITCH_Y - 27 - c_y_o), banner_sprite, Trans
  banner_message = GAME_NAME + " " + Str(GAME_VERSION) + " ::: " + Str(goal_team_0) + "-" + Str(goal_team_1)
  Draw String (PITCH_MIDDLE_W - c_x_o - 120,  PITCH_Y - 20 - c_y_o), banner_message, COLOR_WHITE
  'drawing the grass
  For a = 0 To pitch_cols -1
    For b = 0 To pitch_rows -1
      If is_in_camera_crop (PITCH_X + b*32, PITCH_Y + a*32, 128) Then
        If b Mod 2 = 0 Then
          Put (PITCH_X + (b*32)- c_x_o, PITCH_Y+(a*32) - c_y_o),pitch_sprite(0),Trans
        Else
          Put (PITCH_X + (b*32)- c_x_o, PITCH_Y+(a*32) - c_y_o),pitch_sprite(1),Trans
        End If
      End If
    Next b
  Next a
  'drawing the pitch's lines
  Line (PITCH_X - c_x_o, PITCH_Y - c_y_o)-(PITCH_W+PITCH_X- c_x_o, PITCH_H+PITCH_Y- c_y_o),COLOR_WHITE,b

  Line (PITCH_X+PITCH_W\2 - c_x_o, PITCH_Y - c_y_o)-(PITCH_X+PITCH_W\2 - c_x_o, PITCH_Y+PITCH_H - c_y_o),COLOR_WHITE
  Circle (PITCH_X+PITCH_W\2- c_x_o, PITCH_Y + PITCH_H\2- c_y_o), 84,COLOR_WHITE
  Circle (PITCH_X+PITCH_W\2- c_x_o, PITCH_Y + PITCH_H\2- c_y_o), 2,COLOR_WHITE,,,,F
  Circle (PITCH_X + 102 - c_x_o, PITCH_Y + PITCH_H\2 - c_y_o), 2,COLOR_WHITE,,,,F
  Circle (PITCH_X+PITCH_W - 102 - c_x_o, PITCH_Y + PITCH_H\2 - c_y_o), 2,COLOR_WHITE,,,,F

  Line (PITCH_X - c_x_o, PITCH_Y+PITCH_H\2 - c_y_o-84)-(PITCH_X - c_x_o+51, PITCH_Y+PITCH_H\2 - c_y_o+84),COLOR_WHITE,B
  Line (PITCH_X - c_x_o, PITCH_Y+PITCH_H\2 - c_y_o-186)-(PITCH_X - c_x_o+154, PITCH_Y+PITCH_H\2 - c_y_o+186),COLOR_WHITE,B
  Line (PITCH_X+PITCH_W - c_x_o, PITCH_Y+PITCH_H\2 - c_y_o-84)-(PITCH_X+PITCH_W - c_x_o-51, PITCH_Y+PITCH_H\2 - c_y_o+84),COLOR_WHITE,B
  Line (PITCH_X+PITCH_W - c_x_o, PITCH_Y+PITCH_H\2 - c_y_o-186)-(PITCH_X+PITCH_W - c_x_o-154, PITCH_Y+PITCH_H\2 - c_y_o+186),COLOR_WHITE,B
  Circle (PITCH_X + 102 - c_x_o, PITCH_Y + PITCH_H\2 - c_y_o), 84,COLOR_WHITE,5.4,0.9
  Circle (PITCH_X+PITCH_W - 102 - c_x_o, PITCH_Y + PITCH_H\2 - c_y_o), 84,COLOR_WHITE,2.26,4.04

  Circle (PITCH_X - c_x_o, PITCH_Y - c_y_o), 9, COLOR_WHITE,PI1_5,0
  Circle (PITCH_X - c_x_o, PITCH_Y + PITCH_H - c_y_o), 9, COLOR_WHITE,0,PI2
  Circle (PITCH_X+PITCH_W - c_x_o, PITCH_Y - c_y_o), 9, COLOR_WHITE,PI,PI1_5
  Circle (PITCH_X+PITCH_W - c_x_o, PITCH_Y + PITCH_H - c_y_o), 9, COLOR_WHITE,PI2,PI
  If (DEBUG) Then
    Circle (PITCH_X - c_x_o, PITCH_Y + PITCH_H\2 - c_y_o),  PITCH_PENALTY_AREA, COLOR_WHITE, PI + PI2, PI2 , 1
    Circle (PITCH_X + PITCH_W -c_x_o, PITCH_Y + PITCH_H\2 - c_y_o),  PITCH_PENALTY_AREA, COLOR_WHITE, PI2, PI + PI2, 1
  End If
End Sub

Sub get_user_input()
  'position of the ball
  If MultiKey(SC_SPACE    ) Then ball.z_speed_init = 15 : ball.z_speed=ball.z_speed_init

  If (MultiKey(SC_RIGHT ) And MultiKey(SC_UP)) Then ball.rds = PI4: ball.speed +=1:
  If (MultiKey(SC_LEFT ) And MultiKey(SC_UP)) Then ball.rds = PI4*3: ball.speed +=1:
  If (MultiKey(SC_LEFT ) And MultiKey(SC_DOWN)) Then ball.rds = PI4*5: ball.speed +=1:
  If (MultiKey(SC_RIGHT ) And MultiKey(SC_DOWN)) Then ball.rds = PI4*7: ball.speed +=1:
  If MultiKey(SC_LEFT ) Then ball.rds = -PI : ball.speed +=1:
  If MultiKey(SC_RIGHT) Then ball.rds = 0: ball.speed +=1:
  If MultiKey(SC_UP   ) Then ball.rds = PI2: ball.speed +=1:
  If MultiKey(SC_DOWN   ) Then ball.rds = (PI_2)*.75: ball.speed +=1:

  If MultiKey(SC_D    ) Then  DEBUG Xor = 1 :
End Sub

Sub update_ball()

  ball.old_x = ball.x
  ball.old_y = ball.y
  'this to desn't allow the ball to become a missile
  If ball.speed > BALL_MAX_SPEED Then ball.speed = BALL_MAX_SPEED
  If ball.speed < BALL_MIN_SPEED Then ball.speed = 0

  'ball bounce physics
  If ball.z_speed > 0 Then
    ball.z += ball.z_speed - GRAVITY_ACCEL
    ball.z_speed *= GRAVITY
    ball.speed = ball.speed * AIR_FRICTION
    If (ball.z <=0) Then
      ball.z_speed_init *= BOUNCE_FRICTION
      ball.z_speed = ball.z_speed_init
      ball.z = 0
    End If
  Else
    If ball.z < 0.5 Then ball.z = 0
    ball.speed = ball.speed * friction
  End If

  'ball position
  ball.x += Cos(ball.rds)*ball.speed
  ball.y += -Sin(ball.rds)*ball.speed

  'radiants check -> MOD 2*PI
  If ball.rds > PI_2 Then ball.rds = ball.rds - PI_2
  If ball.rds < 0 Then ball.rds = ball.rds + PI_2

End Sub

Sub draw_ball()
  Dim offset_frame As Integer
  Dim x As Integer

  If (ball.z > 25) Then
    If ball.z < 60 Then
      offset_frame = 5
    Else
      offset_frame = 10
    End If
  Else
    offset_frame = 0
  End If

  If d_b_t_p(ball.x, ball.y, ball.old_x, ball.old_y) > 1 Then
    ball.frame += 1
  End If

  If ball.frame Mod 5 = 0  Then ball.frame = 0

  'shadow
  Circle (ball.x-c_x_o, ball.y-c_y_o+2),ball.w, RGB(0,50,0),,,,F
  Put (ball.x-c_x_o-8, ball.y- 8 - ball.z- c_y_o), ball_sprite(ball.frame + offset_frame), Trans
End Sub

Sub ball_border_pitch_limit_check()
  'goal check team 0
  If (ball.x > PITCH_X + PITCH_W - 5) And (ball.y + ball.w < PITCH_H \2 + PITCH_NET_W\2 + PITCH_Y)_
    And (ball.y + ball.w > PITCH_H \2 - PITCH_NET_W\2 + PITCH_Y) And ball.z < PITCH_NET_H Then
    ball_put_on_centre()
    reset_players_positions()
    goal_team_0 +=1
    camera.speed = 0
    PL_ball_owner_id = -1
    Exit Sub
  End If

  'goal check team 1
  If (ball.x < PITCH_X + 5) And (ball.y + ball.w < PITCH_H \2 + PITCH_NET_W\2 + PITCH_Y)_
    And (ball.y + ball.w > PITCH_H \2 - PITCH_NET_W\2 + PITCH_Y) And ball.z < PITCH_NET_H Then
    ball_put_on_centre()
    reset_players_positions()
    goal_team_1 +=1
    camera.speed = 0
    PL_ball_owner_id = -1
    Exit Sub
  End If

  'border pitch limit check
  If (ball.x + ball.w > PITCH_X+PITCH_W) Then
    ball.x = PITCH_X+PITCH_W-5
    ball.rds = PI - ball.rds
    ball.speed *= 0.3:ball.z_speed *= 0.5
    PL_ball_owner_id = -1
  End If
  If (ball.x - ball.w < PITCH_X) Then
    ball.x = PITCH_X+5
    ball.rds = PI - ball.rds
    ball.speed *= 0.3:ball.z_speed *= 0.5
    PL_ball_owner_id = -1
  End If
  If (ball.y + ball.w > PITCH_Y+PITCH_H) Then
    ball.y = PITCH_Y+PITCH_H-5
    ball.rds = PI_2 - ball.rds
    ball.speed *= 0.3:ball.z_speed *= 0.5
    PL_ball_owner_id = -1
  End If
  If (ball.y - ball.w < PITCH_Y) Then
    ball.y = PITCH_Y+5
    ball.rds = PI_2 - ball.rds
    ball.speed *= 0.3
    ball.z_speed *= 0.5
    PL_ball_owner_id = -1
  End If
End Sub

Sub draw_grid()
  Dim As Integer x, y, x2,y2, col, row, count= 0
  For row = 0 To ROW_TOT_N - 1 Step 1
    For col = COL_TOT_N - 1 To 0 Step -1
      'draw the grid
      x = row * PITCH_W \ ROW_TOT_N + PITCH_X
      y = col * PITCH_H \ COL_TOT_N + PITCH_Y
      x2 = x + PITCH_W \ ROW_TOT_N
      y2 = y + PITCH_H \ COL_TOT_N
      Line (x-c_x_o,y-c_y_o)-(x2-c_x_o,y2-c_y_o),RGB(255,0,255),b
      Draw String (x+5-c_x_o,y+5-c_y_o), Str(count), RGB(75,150,20)
      'check if the ball is into a box of the grid and fill it using paint function
      If (ball.x > x) And (ball.x < x2) And (ball.y>y) And (ball.y < y2) Then
        Paint (ball.x-c_x_o, ball.y-c_y_o),RGB(50,150,15),RGB(255,0,255)
        Draw String (x+5-c_x_o,y+5-c_y_o), Str(count)
      End If
      count +=1
    Next col
  Next row
End Sub

Sub ball_put_on_centre()
  ball.rds = 0
  ball.x = 1+ PITCH_MIDDLE_W
  ball.y = 1+ PITCH_MIDDLE_H
  ball.z = 0
  ball.z_speed = 0
  ball.speed = 0
  ball.w = 4
  ball.frame=0

End Sub

Sub reset_players_positions()
  Dim c As Integer
  For c = 0 To (N_TOT_PL*2-1)
    Select Case c
      'goalkeepers
      Case 0, 1
        If c = 0 Then
          pl(c).x = PITCH_X + 10
          pl(c).y = PITCH_Y + PITCH_H \ 2
          pl(c).rds = 0
        Else
          pl(c).x = PITCH_X + PITCH_W - 10
          pl(c).y = PITCH_Y + PITCH_H \ 2
          pl(c).rds = PI
        End If
        'other players
      Case Else
        If c Mod 2 = 0 Then
          pl(c).x = Rnd * PITCH_W\2 + PITCH_X
          pl(c).y = Rnd * PITCH_H + PITCH_Y
        Else
          pl(c).x = Rnd * PITCH_W\2 + PITCH_X + PITCH_W\2
          pl(c).y = Rnd * PITCH_H + PITCH_Y
        End If
    End Select
    pl(c).active = 1
    pl(c).action = 1
  Next c
End Sub


Sub draw_players()
  Dim As Integer b, c, lowest, start, change
  Dim As Integer ref
  Dim a(N_TOT_PL * 2,2) As Integer
  'z sorting by pl.y value - using selection sorting algorithm
  For c = 0 To N_TOT_PL * 2 - 1
    a(c,0) = c
    a(c,1) = pl(c).y
  Next c

  For start = 0 To N_TOT_PL * 2 - 1
    ref = a(start,1)
    change = 0
    For b = start+1 To N_TOT_PL * 2 - 1
      If a(b,1) < ref Then
        ref = a(b, 1)
        lowest = b
        change = 1
      End If
    Next b
    If change Then
      Swap a(lowest, 0), a(start, 0)
      Swap a(lowest, 1), a(start, 1)
    End If
  Next start

  'draws players, shadow, and circle under nearest pl to the ball
  For c = 0 To N_TOT_PL * 2 - 1
    'draws circles yellow or red under the nearest pl to the ball
    If get_nrst_pl_ball(pl(a(c,0)).team) = a(c,0) Then
      If pl(a(c,0)).team = 0 Then
        Circle (pl(a(c,0)).x - c_x_o, pl(a(c,0)).y+9 - c_y_o),9, RGB(200,0,100),,,,F
        Circle (pl(a(c,0)).x - c_x_o, pl(a(c,0)).y+9 - c_y_o),6, RGB(0,50,0),,,,F

      Else
        Circle (pl(a(c,0)).x- c_x_o, pl(a(c,0)).y+9 - c_y_o),9, RGB(255,255,0),,,,F
        Circle (pl(a(c,0)).x - c_x_o, pl(a(c,0)).y+9 - c_y_o),6, RGB(0,50,0),,,,F

      End If
      Draw String (pl(a(c,0)).x -6- c_x_o, pl(a(c,0)).y -30  - c_y_o), Str(pl(a(c,0)).number)
      'draw string (pl(a(c,0)).x -6- c_x_o, pl(a(c,0)).y -60  - c_y_o), str(pl(a(c,0)).speed)    'DEBUG
      'draw string (pl(a(c,0)).x -6- c_x_o, pl(a(c,0)).y -45  - c_y_o), str(pl(a(c,0)).active)    'DEBUG
    End If

    'puts the right set of sprites depending on the pl.action
    If is_in_camera_crop (pl(a(c,0)).x, pl(a(c,0)).y, 128) Then
      Select Case pl(a(c,0)).action
        Case 0 '*** at this moment undefined***
        Case 1 'RUNNING############################################################
          pl(a(c,0)).dist += pl(a(c,0)).speed /7
          If pl(a(c,0)).dist > 1 Then
            pl(a(c,0)).frame+=1
            pl(a(c,0)).dist =0
          End If
          If pl(a(c,0)).speed = 0 Then pl((a(c,0))).frame = 0
          If pl(a(c,0)).frame > 5 Then pl(a(c,0)).frame=1
          If pl(a(c,0)).team = 0 Then
            Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
            pl_sprite_0(start_frame(pl(a(c,0)).rds)+pl(a(c,0)).frame), Trans
          Else
            Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
            pl_sprite_1(start_frame(pl(a(c,0)).rds)+pl(a(c,0)).frame), Trans
          End If
        Case 2 'JUMPING for HEADKICKS##############################################
          If pl(a(c,0)).team = 0 Then
            Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
            pl_sprite_0(start_frame(pl(a(c,0)).rds)+13), Trans
          Else
            Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
            pl_sprite_1(start_frame(pl(a(c,0)).rds)+13), Trans
          End If
        Case 3 'SLIDING ###########################################################
          If pl(a(c,0)).team = 0 Then
            Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
            pl_sprite_0(start_frame(pl(a(c,0)).rds)+12), Trans
          Else
            Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
            pl_sprite_1(start_frame(pl(a(c,0)).rds)+12), Trans
          End If
        Case 4 'FALLING ###########################################################
          pl(a(c,0)).frame_offset +=1
          If pl(a(c,0)).frame_offset > 9 Then pl(a(c,0)).frame_offset = 0
          If pl(a(c,0)).team = 0 Then
            Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
            pl_sprite_0(start_frame(pl(a(c,0)).rds)+Int(pl(a(c,0)).frame_offset/2)+6), Trans
          Else
            Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
            pl_sprite_1(start_frame(pl(a(c,0)).rds)+Int(pl(a(c,0)).frame_offset/2)+6), Trans
          End If
        Case 5
          If pl(a(c,0)).team = 0 Then
            Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
            pl_sprite_0(start_frame(pl(a(c,0)).rds)+6), Trans
          Else
            Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
            pl_sprite_1(start_frame(pl(a(c,0)).rds)+6), Trans
          End If
        Case Else
      End Select
    End If
  Next c

End Sub

Sub update_players()
  Dim As Integer c, decision, pl_to_pass
  Dim As Single trg_x, trg_y

  'the following is a very bad try to give a decent AI to the players
  For c = 0 To N_TOT_PL * 2 - 1
    'this is useful for the pl behaviour
    decision = Rnd*100
    'this is useful for the sprites
    pl(c).old_x = pl(c).x
    pl(c).old_y = pl(c).y
    'delay check
    If pl(c).active = 0 Then
      pl(c).delay -=1
    End If

    Select Case pl(c).action
      Case 0
      Case 1 '#### RUNNING ##########################################################
        'goalkeepers routine
        If c < 2 Then
          trg_x = PITCH_X + 25 +((PITCH_W - 50) * (pl(c).team Xor 0))
          trg_y = PITCH_MIDDLE_H
          ' if the ball is into the area then the GK runs to the ball
          If d_b_t_p(trg_x, trg_y, ball.x, ball.y) < PITCH_PENALTY_AREA -50 Then
            pl(c).rds = a_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y)
            pl(c).speed = 5
            ' if the ball is VERY near, kick off the ball
            If d_b_t_p(pl(c).x,pl(c).y, ball.x, ball.y) < 15 And ball.z < 15 Then
              ball.speed = 7*Rnd+10
              ball.z_speed_init = 10 + Rnd*5 : ball.z_speed=ball.z_speed_init
              ball.rds = PI * (pl(c).team Xor 0)
              PL_target_id = -1 ' The GK is not passing to anyone
              PL_ball_owner_id = c ' The pl become the ball owner
            End If
            'else return to the net
          Else
            'keep running to the net until the distance is more than 5
            If d_b_t_p(pl(c).x, pl(c).y, trg_x, trg_y) > 5 Then
              pl(c).rds = a_b_t_p(pl(c).x,pl(c).y, trg_x, trg_y)
              pl(c).speed = 3
              'when get the net stay there
            Else
              pl(c).speed = 0
              pl(c).x = trg_x
              pl(c).y = trg_y
              'when stay in the net always watch the ball
              pl(c).rds = a_b_t_p(pl(c).x,pl(c).y, ball.x, ball.y)
            End If
          End If
        Else
          'routine for other players (defenders, midfielders, attackers)#########
          'if the pl(c) is the nearest to the ball and is ready to perform an
          'action then run there
          If get_nrst_pl_ball(pl(c).team) = c Then
            'run to the ball and restore original speed of the player
            pl(c).speed = pl(c).speed_default
            pl(c).rds =  a_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y)
            ' try to catch the ball with SLIDING###############################
            'if the pl slider is not receiving the ball and if
            'the ball distance is into a specified range (in this case >30 <50)
            '(...) and also important: the ball.z must be less than a fixed value
            If (decision > 90 And (PL_ball_owner_id <> c) And (PL_target_id <> c)_
              And (d_b_t_p(pl(c).x, pl(c).y,ball.x, ball.y)) < 50 _
              And (d_b_t_p(pl(c).x, pl(c).y,ball.x, ball.y)) > 30 _
              And ball.z < 5) Then
              pl(c).speed = 15
              pl(c).delay = 20
              pl(c).action = 3 '3 = sliding
              Continue For
            End If
            'try to hit the ball with HEADKICK################################
            'if the ball is near and its z value is greater than a fixed value
            'then the player tries to hit it with headkick
            If (decision > 80 And (PL_ball_owner_id <> c) _
              And (d_b_t_p(pl(c).x, pl(c).y,ball.x, ball.y)) < 40 _
              And ball.z > 6 And ball.z < 30) Then
              pl(c).speed = 12
              pl(c).delay = 10
              pl(c).action = 2 '3 = sliding
              Continue For
            End If
            'if the ball is very near and at the same z level of the pl the
            'pl became owner of the ball
            '#PLAYER OWNER OF THE BALL#
            If d_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y) < 6 And ball.z < 4 Then
              ' if there is enough room - run to the opponent net
              If d_b_t_p (pl(c).x,pl(c).y,_
                pl(get_nrst_pl_ball(pl(c).team Xor 1)).x,_
                pl(get_nrst_pl_ball(pl(c).team Xor 1)).y) > PL_RUN_SPACE Then
                reset_ball_z()
                ball.rds = a_b_t_p (pl(c).x, pl(c).y,_
                PITCH_X + (PITCH_W * (pl(c).team Xor 1)), PITCH_MIDDLE_H) + Rnd * .5 -.25
                ball.speed = pl(c).speed + Rnd*2 + 1
                PL_target_id = -1 ' The pl is not passing to anyone
                PL_ball_owner_id = c ' The pl become the ball owner
              Else
                'get the pl behaviour
                get_pl_behavior(c)
              End If
              Continue For
            End If
            'else follow the tactics
          Else
            ' if the pl owns the id that is receiving the ball, him runs to the
            'ball with a little speed help
            If c = PL_target_id Then
              pl(c).rds = a_b_t_p(pl(c).x,pl(c).y, ball.x, ball.y)
              pl(c).speed = pl(c).speed_default * 1.2
            Else
              'else follow the tactics
              pl(c).speed = pl(c).speed_default
              pl(c).rds = get_rds_from_tile(get_tact_tile(c),pl(c).x + pl(c).tact_offset_x,pl(c).y+ pl(c).tact_offset_y)
              If get_dist_from_tile (get_tact_tile(c), pl(c).x + pl(c).tact_offset_x,pl(c).y + pl(c).tact_offset_y) < 5 Then
                pl(c).speed = 0
                'offset to the tactic to move randomly the the player (I don't like mummies)
                If Int(Rnd * 100) > 85 Then
                  pl(c).tact_offset_x = Rnd * 30-15
                  pl(c).tact_offset_y = Rnd * 30-15
                End If
              Else
                pl(c).speed = pl(c).speed_default
              End If
            End If
          End If
        End If
      Case 2 'HEADKICKING#####################################################################
        pl(c).speed *= 0.85 'friction of the pl body with the air
        pl(c).delay -= 1
        'if the delay time has passed
        If pl(c).delay < 1 Then
          pl(c).action = 1
          pl(c).delay = PL_DELAY_FALLED
        End If
        'Oh yeah, I can headkicking, the ball is so near!
        If (d_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y) < 20 And ball.z < 20 And ball.z > 6) Then
          ball.rds = pl(c).rds + PI4
          ball.speed = pl(c).speed + Rnd * 5 + 5
          If (Int(Rnd*10)> 5) Then
            ball.z_speed_init = 10 : ball.z_speed=ball.z_speed_init
          End If
          PL_ball_owner_id = c
          pl(c).speed = pl(c).speed_default
        End If
      Case 3 'SLIDING#####################################################################
        pl(c).speed *= 0.80 'friction of the pl body with the grass
        pl(c).delay -= 1
        'if the delay time has passed or the pl has catched the ball
        If pl(c).delay < 1 Or _
          (d_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y) < 6 And ball.z < 4) Then
          pl(c).action = 1
          pl(c).delay = PL_DELAY_FALLED
          pl(c).speed = pl(c).speed_default
        End If
      Case 4 'falling ... delays and goto falled
        pl(c).speed *=0.1
        If pl(c).delay < 1 Then
          pl(c).action = 5
          pl(c).delay = PL_DELAY_FALLED
        End If
      Case 5 'falled
        pl(c).speed = 0
        If pl(c).delay < 1 Then
          pl(c).active = 1
          pl(c).action = 1
          pl(c).delay = PL_DELAY_FALLED
          pl(c).speed = pl(c).speed_default
        End If
      Case Else
    End Select
    'pl limit check, don't go outside the PITCH
    If pl(c).x > PITCH_W + PITCH_X Then pl(c).rds = a_b_t_p(pl(c).x, pl(c).y,PITCH_MIDDLE_W,PITCH_MIDDLE_H)
    If pl(c).x < PITCH_X Then pl(c).rds = a_b_t_p(pl(c).x, pl(c).y,PITCH_MIDDLE_W,PITCH_MIDDLE_H)
    If pl(c).y > PITCH_H + PITCH_Y Then pl(c).rds = a_b_t_p(pl(c).x, pl(c).y,PITCH_MIDDLE_W,PITCH_MIDDLE_H)
    If pl(c).y < PITCH_Y Then pl(c).rds = a_b_t_p(pl(c).x, pl(c).y,PITCH_MIDDLE_W,PITCH_MIDDLE_H)

    '###IMPORTANT!#####
    'update pl position moving him
    pl(c).x +=  Cos(pl(c).rds)*pl(c).speed
    pl(c).y +=  -Sin(pl(c).rds)*pl(c).speed
  Next c
End Sub

Sub camera_update_position()
  camera.speed = d_b_t_p(camera.x, camera.y, ball.x, ball.y) / 6
  camera.x += Cos(a_b_t_p(camera.x, camera.y, ball.x, ball.y))*camera.speed
  camera.y += -Sin(a_b_t_p(camera.x, camera.y, ball.x, ball.y))*camera.speed

  'padding & border limit check
  If (camera.x < PITCH_X + camera.w/2 - CAMERA_PADDING) Then
    camera.x = PITCH_X + camera.w/2 - CAMERA_PADDING
  End If
  If (camera.x > PITCH_X + PITCH_W - camera.w/2 + CAMERA_PADDING) Then
    camera.x = PITCH_X + PITCH_W - camera.w/2 + CAMERA_PADDING
  End If
  If (camera.y > PITCH_Y + PITCH_H - camera.h/2 + CAMERA_PADDING) Then
    camera.y = PITCH_Y + PITCH_H - camera.h/2 + CAMERA_PADDING
  End If
  If (camera.y < PITCH_Y + camera.h/2 - CAMERA_PADDING) Then
    camera.y = PITCH_Y + camera.h/2 - CAMERA_PADDING
  End If
  'update global variables
  c_x_o = camera.x - camera.w/2
  c_y_o = camera.y - camera.h/2
End Sub

Sub init_players_proprietes()
  'initializing players proprietes
  Dim c As Integer
  For c = 0 To (N_TOT_PL*2-1)
    Select Case c
      'goalkeepers
      Case 0, 1
        If c = 0 Then
          pl(c).id = c
          pl(c).team = 0
          pl(c).number = Int (c \ 2)+1
          pl(c).x = PITCH_X + 10
          pl(c).y = PITCH_Y + PITCH_H \ 2
          pl(c).rds = 0
          pl(c).speed_default = 0
          pl(c).speed = pl(c).speed_default
        Else
          pl(c).id = c
          pl(c).team = 1
          pl(c).number = Int (c \ 2)+1
          pl(c).x = PITCH_X + PITCH_W - 10
          pl(c).y = PITCH_Y + PITCH_H \ 2
          pl(c).rds = PI
          pl(c).speed_default = 0
          pl(c).speed = pl(c).speed_default
        End If
        pl(c).frame = 0

        pl(c).tact_offset_x = Rnd * 60 - 30
        pl(c).tact_offset_y = Rnd * 60 - 30
        pl(c).ball_radius = 25
        pl(c).w = 10
        pl(c).delay = PL_DELAY_TIME
        pl(c).active = 1 ' by default the pl is ready to perform any action
        pl(c).action = 1 'by default the pl can run
        'other players
      Case Else
        If c Mod 2 = 0 Then
          pl(c).id = c
          pl(c).team = 0
          pl(c).number = Int (c \ 2)+1
          pl(c).x = Rnd * PITCH_W\2 + PITCH_X
          pl(c).y = Rnd * PITCH_H + PITCH_Y

        Else
          pl(c).id = c
          pl(c).team = 1
          pl(c).number = Int (c \ 2)+1
          pl(c).x = Rnd * PITCH_W\2 + PITCH_X + PITCH_W\2
          pl(c).y = Rnd * PITCH_H + PITCH_Y
        End If
        pl(c).rds = 0
        pl(c).frame = 0
        pl(c).frame_offset = 0
        pl(c).dist = 0
        pl(c).speed_default = Rnd*(PL_DEFAULT_SPEED*2) + PL_DEFAULT_SPEED*2
        pl(c).speed = pl(c).speed_default

        pl(c).tact_offset_x = Rnd * 60 - 30
        pl(c).tact_offset_y = Rnd * 60 - 30
        pl(c).ball_radius = 25
        pl(c).w = 10
        pl(c).delay = PL_DELAY_TIME
        pl(c).active = 1 ' by default the pl is ready to perform any action
        pl(c).action = 1 'by default the pl can run
    End Select
  Next c
  'initialize who is receiving the ball (none)
  PL_target_id = -1
End Sub

Sub draw_nets()

  'left net
  Line (PITCH_X - c_x_o, PITCH_MIDDLE_H - c_y_o)-(PITCH_X + 5 - c_x_o, PITCH_MIDDLE_h - c_y_o)
  Line (PITCH_X - c_x_o, PITCH_MIDDLE_H + PITCH_NET_W\2- c_y_o)-(PITCH_X + 5 - c_x_o, PITCH_MIDDLE_H + PITCH_NET_W\2 - c_y_o)
  Line (PITCH_X - c_x_o, PITCH_MIDDLE_H - PITCH_NET_W\2- c_y_o)-(PITCH_X + 5 - c_x_o, PITCH_MIDDLE_H - PITCH_NET_W\2 - c_y_o)

  'right net
  Line (PITCH_X + PITCH_W - c_x_o, PITCH_MIDDLE_H - c_y_o)-(PITCH_X - 5 + PITCH_W - c_x_o, PITCH_MIDDLE_H - c_y_o)
  Line (PITCH_X + PITCH_W -c_x_o, PITCH_MIDDLE_H + PITCH_NET_W\2- c_y_o)-(PITCH_X + PITCH_W - 5 - c_x_o, PITCH_MIDDLE_H + PITCH_NET_W\2 - c_y_o)
  Line (PITCH_X + PITCH_W - c_x_o, PITCH_MIDDLE_H - PITCH_NET_W\2- c_y_o)-(PITCH_X + PITCH_W - 5 - c_x_o, PITCH_MIDDLE_H - PITCH_NET_W\2 - c_y_o)

  Put (PITCH_X - 50 - c_x_o, PITCH_MIDDLE_H - PITCH_NET_W\2 - PITCH_NET_H - c_y_o ), net_sprite(0), Trans
  Put (PITCH_X + PITCH_W - c_x_o, PITCH_MIDDLE_H - PITCH_NET_W\2 - PITCH_NET_H - c_y_o ), net_sprite(1), Trans

End Sub


Sub load_tact()
  'the "tct_tile" array indicates in wich tile the player must be with corresponding
  'ball position. For example: ball in tile 0 -> read from tct_tile(0) = player in tile 1
  Dim As Integer tl, c

  For c = 0 To 9
    For tl = 0 To 35
      Read tct_tile(c,tl)
    Next tl
  Next c

End Sub

'TACT DATA
'each row represents in wich tile the pl must go when he doesn't own the ball
'So, the defender (id: 1) must go to these tiles:
'DATA 	1,1,2,2,2,2,7,7,2,2 [...] etc
' when the ball is in the tile 0, he must go to tile 1
' when the ball is in the tile 1, he must go to tile 1
' when the ball is in the tile 2, he must go to tile 2 [...] and so on...

Data    1,1,1,1,1,1,1,1,1,1,1,1,7,7,7,7,7,7,7,7,7,7,7,7,13,13,13,13,13,13,13,13,13,13,13,13
Data    2,2,2,2,2,2,2,2,2,2,2,2,8,8,8,8,8,8,8,8,8,8,8,8,14,14,14,14,14,14,14,14,14,14,14,14
Data    3,3,3,3,3,3,3,3,3,3,3,3,9,9,9,9,9,9,9,9,9,9,9,9,9,15,15,15,15,15,15,15,15,15,15,15
Data    4,4,4,4,4,4,4,4,4,4,4,4,10,10,10,10,10,10,10,10,10,10,10,10,16,16,16,16,16,16,16,16,16,16,16,16
Data    12,13,13,13,13,13,12,13,13,13,13,13,13,13,13,13,13,13,19,19,19,19,19,19,19,19,19,25,25,25,30,25,25,25,25,25
Data    14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,20,20,20,20,20,20,26,26,26,26,26,26,25,26,26,26,26,26
Data    15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,21,21,21,21,21,21,27,27,27,27,27,27,27,27,27,27,27,28
Data    17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,22,22,22,22,22,22,22,22,22,22,28,28,28,28,28,28,28,35
Data    20,20,20,20,20,20,20,20,20,20,20,20,26,26,26,26,26,26,26,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32
Data    21,21,21,21,21,21,21,21,21,21,21,21,27,27,27,27,27,27,27,33,33,33,33,28,33,33,33,33,33,33,33,33,33,33,33,33

'see comment below for details about the bhv_tile array
Sub load_behavior()
  Dim As Integer tl, c, temp
  'read and store into array
  For tl = 0 To 35
    For c = 0 To 9
      Read bhv_tile(tl,c)
    Next c
  Next tl
  'transform 10, 20, 35 -> 10, (20+10) = 30, (10+20+35) = 65 [...] and so on
  For tl = 0 To 35
    For c = 1 To 9
      temp = bhv_tile(tl,c-1)
      bhv_tile(tl,c) += temp
    Next c
  Next tl

End Sub
'BEHAVIOR DATA
'each row represents the behavior of the player OWNER of the ball in "x" tile
'every column represents a percentage [...]
'So, if the pl owns the ball in the 0 tile he could:
'DATA    [tile 0] 10,20,10,20,4,4,10,4,18,0
' 10% pass to nearest, 20% pass to 2nd nearest, 10% pass by short side,
'20% pass longside, 4% pass to the endline pl [...] and so on...

'fields meaning:
'0: pass_to_nearest; 1: pass_to_2nd_nearest; 2: pass_short_side; 3: pass_long_side
'4:pass_endline; 5: pass_center; 6: run_to_centre; 7: run_to_net
'8: run_to_endline; 9: shoot_in_target
'(see functions meaning on the top of this file)
'IMPORTANT: the SUM of each row is always 100

Data    10,20,10,20,4,4,10,4,18,0
Data    5,10,5,27,4,4,15,10,20,0
Data    4,12,3,35,8,13,10,5,10,0
Data    4,12,3,35,8,13,10,5,10,0
Data    5,10,5,27,4,4,15,10,20,0
Data    10,20,10,20,4,4,10,4,18,0
Data    7,10,7,25,5,15,10,3,18,0
Data    5,12,7,21,6,18,13,3,15,0
Data    2,7,10,22,7,21,13,3,15,0
Data    2,7,10,22,7,21,13,3,15,0
Data    5,12,7,21,6,18,13,3,15,0
Data    7,10,7,25,5,15,10,3,18,0
Data    8,9,8,13,15,13,14,8,12,0
Data    7,8,9,12,16,18,10,9,11,0
Data    7,11,11,14,14,7,7,14,15,0
Data    7,11,11,14,14,7,7,14,15,0
Data    7,8,9,12,16,18,10,9,11,0
Data    8,9,8,13,15,13,14,8,12,0
Data    5,10,7,15,20,6,6,13,13,5
Data    4,9,10,18,20,6,5,12,10,6
Data    3,10,9,15,25,3,2,13,12,8
Data    3,10,9,15,25,3,2,13,12,8
Data    4,9,10,18,20,6,5,12,10,6
Data    5,10,7,15,20,6,6,13,13,5
Data    10,10,7,7,15,2,7,16,15,11
Data    10,10,10,5,18,3,8,10,10,16
Data    8,8,12,12,17,0,3,10,10,20
Data    8,8,12,12,17,0,3,10,10,20
Data    10,10,10,5,18,3,8,10,10,16
Data    10,10,7,7,15,2,7,16,15,11
Data    5,7,15,5,25,8,7,13,3,12
Data    3,4,4,2,21,2,6,22,1,35
Data    2,2,2,2,20,6,4,16,1,45
Data    2,2,2,2,20,6,4,16,1,45
Data    3,4,4,2,21,2,6,22,1,35
Data    5,7,15,5,25,8,7,13,3,12

Sub get_pl_behavior(pl_id As Integer)
  Dim tile As Integer '0-35
  Dim decision As Integer '0-100
  Dim pl_to_pass As Integer = 0

  decision = Rnd*101
  tile = get_ball_tile(pl(pl_id).team)

  Select Case decision
    Case 0 To bhv_tile(tile, 0) '0: PASS TO NEAREST
      SHELL_message =  Str(decision) + " TILE " + Str(tile) + " PASS to nearest"
      'setting ball proprietes (z, angle, speed)
      reset_ball_z()
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,pl(get_nrst_pl_pass(pl_id)).x,pl(get_nrst_pl_pass(pl_id)).y)+Rnd*.3-0.15
      ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
      pl(get_nrst_pl_pass(pl_id)).x,pl(get_nrst_pl_pass(pl_id)).y))

      PL_target_id = get_nrst_pl_pass(pl_id)
      PL_ball_owner_id = pl_id

      Exit Sub
    Case bhv_tile(tile, 0)+1 To bhv_tile(tile, 1)'1: pass_to_2nd_nearest
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " PASS 2nd nearest"
      pl_to_pass = Rnd*2 + 1

      'setting ball proprietes (z, angle, speed)
      reset_ball_z()
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
      pl(get_nrst2_pl_pass(pl_id, pl_to_pass)).x,pl(get_nrst2_pl_pass(pl_id,pl_to_pass)).y)+Rnd*.3-0.15
      ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
      pl(get_nrst2_pl_pass(pl_id, pl_to_pass)).x,pl(get_nrst2_pl_pass(pl_id,pl_to_pass)).y))

      PL_target_id = get_nrst2_pl_pass(pl_id,pl_to_pass)
      PL_ball_owner_id = pl_id
      Exit Sub
    Case bhv_tile(tile, 1)+1 To bhv_tile(tile, 2)'2: pass_short_side
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " PASS Short Side"

      'setting ball proprietes (z, angle, speed)
      reset_ball_z()
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,pl(get_shortside_pl_to_pass(pl_id)).x,pl(get_shortside_pl_to_pass(pl_id)).y)+Rnd*.3-0.15
      ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
      pl(get_shortside_pl_to_pass(pl_id)).x,pl(get_shortside_pl_to_pass(pl_id)).y))

      PL_target_id = get_shortside_pl_to_pass(pl_id)
      PL_ball_owner_id = pl_id

      Exit Sub
    Case bhv_tile(tile, 2)+1 To bhv_tile(tile, 3)'3: pass_long_side
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " PASS Long Side"

      reset_ball_z()
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
      pl(get_longside_pl_to_pass(pl_id)).x,pl(get_longside_pl_to_pass(pl_id)).y)
      ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
      pl(get_longside_pl_to_pass(pl_id)).x,pl(get_longside_pl_to_pass(pl_id)).y))

      PL_target_id = get_longside_pl_to_pass(pl_id)
      PL_ball_owner_id = pl_id
      Exit Sub
    Case bhv_tile(tile, 3)+1 To bhv_tile(tile, 4)'4: pass_endline
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " PASS Endline"

      'setting ball proprietes (z, angle, speed)

      If decision Mod 2 = 0 Then
        reset_ball_z()
        ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
        pl(get_endline_pl_to_pass(pl_id)).x,pl(get_endline_pl_to_pass(pl_id)).y))
      Else
        ball.z_speed_init = Rnd*5+7 : ball.z_speed=ball.z_speed_init
        ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
        pl(get_endline_pl_to_pass(pl_id)).x,pl(get_endline_pl_to_pass(pl_id)).y)) / 5
      End If
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
      pl(get_endline_pl_to_pass(pl_id)).x,pl(get_endline_pl_to_pass(pl_id)).y)

      PL_target_id = get_endline_pl_to_pass(pl_id)
      PL_ball_owner_id = pl_id
      Exit Sub
    Case bhv_tile(tile, 4)+1 To bhv_tile(tile, 5)'5: pass_center
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " PASS center"

      reset_ball_z()
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
      pl(get_centerest_pl_to_pass(pl_id)).x,pl(get_centerest_pl_to_pass(pl_id)).y)
      ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
      pl(get_centerest_pl_to_pass(pl_id)).x,pl(get_centerest_pl_to_pass(pl_id)).y))

      PL_target_id = get_centerest_pl_to_pass(pl_id)
      PL_ball_owner_id = pl_id

      Exit Sub
    Case bhv_tile(tile, 5)+1 To bhv_tile(tile, 6)'6: run_to_centre
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " R U N centre"
      ball.speed = pl(pl_id).speed + Rnd*5 + 1
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y, pl(pl_id).x, PITCH_MIDDLE_H) + Rnd * .5 -.25
      PL_target_id = -1 ' The pl is not passing to anyone
      PL_ball_owner_id = pl_id ' The pl become the ball owner
      Exit Sub
    Case bhv_tile(tile, 6)+1 To bhv_tile(tile, 7)'7: run_to_net
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " R U N to net"

      reset_ball_z()

      ' 1 xor 1 = 0 so 0*PITCH_W = 0 else 1*PITCH_W = PITCH_W
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
      PITCH_X + (PITCH_W * (pl(pl_id).team Xor 1)), PITCH_MIDDLE_H) + Rnd * .5 -.25
      ball.speed = pl(pl_id).speed + Rnd*5 + 1
      PL_target_id = -1 ' The pl is not passing to anyone
      PL_ball_owner_id = pl_id ' The pl become the ball owner
      Exit Sub
    Case bhv_tile(tile, 7)+1 To bhv_tile(tile, 8)'8: run_to_endline
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " R U N to endline"

      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
      PITCH_X + (PITCH_W * (pl(pl_id).team Xor 1)), pl(pl_id).y+1) + Rnd * .5 -.25
      ball.speed = pl(pl_id).speed + Rnd*5 + 1
      PL_target_id = -1 ' The pl is not passing to anyone
      PL_ball_owner_id = pl_id ' The pl become the ball owner

      'debug

      Exit Sub
    Case bhv_tile(tile, 8)+1 To 100             '9: shoot_in_target
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " SHOOT in TARGET"

      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
      PITCH_X + (PITCH_W * (pl(pl_id).team Xor 1)), PITCH_MIDDLE_H) + Rnd * .5 -.25

      If decision Mod 2 = 0 Then
        ball.speed = 5*Rnd+10
        ball.z_speed_init = Rnd*5+9 : ball.z_speed=ball.z_speed_init
      Else
        reset_ball_z()
        ball.speed = 2*Rnd+18
        ball.z_speed_init = 10 : ball.z_speed=ball.z_speed_init
      End If


      PL_target_id = -1 ' The pl is not passing to anyone
      PL_ball_owner_id = pl_id ' The pl become the ball owner
      Exit Sub
    Case Else
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " *** SORRY <undefined>"
      Exit Sub

  End Select

End Sub

Sub reset_ball_z()
  ball.z = 0
  ball.z_speed = 0
  ball.z_speed_init = 0
End Sub

Sub check_pl_collisions()
  Dim c As Integer
  Dim d As Integer
  'check each pl
  For c = 0 To (N_TOT_PL*2-1)
    'check collision only if the interested pllayers are int the crop view
    If is_in_camera_crop (pl(c).x, pl(c).y, 64) Then
      For d  = 0 To (N_TOT_PL*2-1)
        If d = c Or pl(d).active = 0 Then Continue For 'doesn't check himself obviously :)
        If d_b_t_p (pl(c).x, pl(c).y,pl(d).x, pl(d).y) < PL_MIN_DIST Then
          'some fighting betweeen two players
          pl(d).x = pl(d).old_x + PL_MIN_DIST\2 - (Rnd*PL_MIN_DIST)
          pl(d).y = pl(d).old_y + PL_MIN_DIST\2 - (Rnd*PL_MIN_DIST)
          'pl(c).x = pl(c).old_x + PL_MIN_DIST/2 - (rnd*PL_MIN_DIST)
          'pl(c).y = pl(c).old_y + PL_MIN_DIST/2 - (rnd*PL_MIN_DIST)

          'one of the may fall if the d pl is sliding
          If Int(Rnd*10) > 3 And pl(d).action = 3 Then
            pl(c).active = 0
            pl(c).action = 4
            pl(c).delay = PL_DELAY_FALLING
            pl(d).action = 1
            Continue For, For
          End If
          'also with running fighting one of the pl may fall
          If Int(Rnd*10) > 9 Then
            pl(c).active = 0
            pl(c).action = 4
            pl(c).delay = PL_DELAY_FALLING
            Continue For, For
          End If
          Continue For, For
        End If
      Next d
    End If
  Next c

End Sub

Sub draw_bottom_info()
  Dim d As Integer

  For d = 0 To Int (SCREEN_W \ 32) +1
    Put (32*d, SCREEN_H-32), shadowed_sprite, Trans
  Next

  Draw String (20,SCREEN_H - 20), Str(goal_team_0) + "-" + Str(goal_team_1)
  Draw String (64,SCREEN_H - 20), SHELL_message, RGB(200,200,200)
End Sub

Function d_t_r (degree As Integer) As Single
  Return Int (degree * PI/180f)
End Function

Function r_t_d (radiants As Integer) As Integer
  Return Int ((radiants * 360f) / PI_2)
End Function

Function a_b_t_p (x1 As Single, y1 As Single, x2 As Single, y2 As Single) As Single
  If (x1>x2) Then
    If (y1>y2) Then
      Return Asin ((x1-x2)/Sqr(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2)))) + PI2
    Else
      Return PI1_5 - Asin ((x1-x2)/Sqr(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2))))
    End If
  Else
    If (y1>y2) Then
      Return PI2 - Asin ((x2-x1)/Sqr(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2))))
    Else
      Return PI1_5  - Asin ((x1-x2)/Sqr(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2))))
    End If
  End If
End Function

Function d_b_t_p (x1 As Single, y1 As Single, x2 As Single, y2 As Single) As Single
  Return Sqr(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2)))'faster
End Function

Function start_frame (radiants As Single) As Integer
  Dim degree As Integer
  'convert radiants to degree - not calling the function, it is much faster
  degree = Int((radiants * 360f) / (PI_2))
  Select Case degree
    Case 0 To 22
      Return 0
    Case 23 To 67
      Return 14
    Case 68 To 112
      Return 28
    Case 113 To 157
      Return 42
    Case 158 To 202
      Return 56
    Case 203 To 247
      Return 70
    Case 248 To 292
      Return 84
    Case 292 To 337
      Return 98
    Case 337 To 360
      Return 0
    Case Else
      Return 14
  End Select
End Function

Function get_tact_tile (pl_id As Integer) As Integer
  '    'this routine find were the ball is and return the tile where the player must go
  Dim tile As Integer
  Dim number As Integer

  tile = tct_tile(pl(pl_id).number-2, get_ball_tile(pl(pl_id).team))

  If pl(pl_id).team = 0 Then
    Return tile
  Else
    Return TILES_N_TOT - tile
  End If

End Function

Function  get_rds_from_tile(tile As Integer, pl_x As Single, pl_y As Single) As Single
  Dim As Integer tile_row, tile_col, x_trg, y_trg

  tile_row = tile Mod COL_TOT_N
  tile_col = Int(tile/COL_TOT_N)

  x_trg = (tile_col * PITCH_W\COL_TOT_N) + PITCH_X + (PITCH_W\COL_TOT_N)\2
  y_trg = PITCH_H - (tile_row * PITCH_H\ROW_TOT_N) + PITCH_Y - (PITCH_H\ROW_TOT_N)\2

  'just to don't allow the player to disappear
  If x_trg > PITCH_X + PITCH_W Or y_trg > PITCH_Y + PITCH_H Then
    x_trg = PITCH_X + PITCH_W \2
    y_trg = PITCH_Y + PITCH_H \2
  End If

  Return a_b_t_p (pl_x,pl_y,x_trg,y_trg)
End Function

Function get_dist_from_tile(tile As Integer, pl_x As Single, pl_y As Single) As Single
  Dim As Integer tile_row, tile_col, x_trg, y_trg

  tile_row = tile Mod COL_TOT_N
  tile_col = Int(tile\COL_TOT_N)

  x_trg = (tile_col * PITCH_W\COL_TOT_N) + PITCH_X + (PITCH_W\COL_TOT_N)\2
  y_trg = PITCH_H - (tile_row * PITCH_H\ROW_TOT_N) + PITCH_Y - (PITCH_H\ROW_TOT_N)\2

  Return d_b_t_p (pl_x,pl_y,x_trg,y_trg)

End Function

Function get_nrst_pl_ball(n_team As Integer) As Integer
  Dim max_dist As Integer = 10000
  Dim c As Integer
  Dim id As Integer

  'start from id 2 or 3 to don't inlude goalkeepers
  If n_team = 0 Then
    For c = 2 To N_TOT_PL * 2-1 Step 2
      If d_b_t_p(pl(c).x,pl(c).y,ball.x,ball.y) < max_dist And pl(c).active = 1 Then
        max_dist = d_b_t_p(pl(c).x,pl(c).y,ball.x,ball.y)
        id = c
      End If
    Next c

    Return id
  Else
    For c = 3 To N_TOT_PL * 2-1 Step 2
      If d_b_t_p(pl(c).x,pl(c).y,ball.x,ball.y) < max_dist And pl(c).active = 1 Then
        max_dist = d_b_t_p(pl(c).x,pl(c).y,ball.x,ball.y)
        id = c
      End If
    Next c

    Return id
  End If
End Function

Function get_nrst_pl_pass(pl_id As Integer) As Integer
  Dim max_dist As Integer = 10000
  Dim As Integer c, id, n_team
  n_team = pl(pl_id).team
  For c = 0 To N_TOT_PL * 2-1
    If c = pl_id Or pl(c).team <> n_team Then Continue For 'don't pass himself ot to a player of the other team
    If d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y) < max_dist Then
      max_dist = d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y)
      id = c
    End If
  Next c

  Return id
End Function

Function get_longside_pl_to_pass (pl_id As Integer) As Integer

  Dim a(N_TOT_PL,2) As Integer
  Dim As Integer tile, c, id
  Dim max_dist As Integer = 10000
  'gets the ball's tile and search the nearest pl to pass who is in the horizontal next tile
  tile = get_ball_tile(pl(pl_id).team)
  If tile <=29 Then
    tile += COL_TOT_N
  End If

  If pl(pl_id).team <> 0 Then tile = TILES_N_TOT - tile

  For c = 0 To N_TOT_PL * 2-1
    If c = pl_id Or pl(c).team <> pl(pl_id).team Then Continue For 'don't pass himself or to a player of the other team
    If get_dist_from_tile(tile, pl(c).x, pl(c).y) < max_dist Then
      max_dist = get_dist_from_tile(tile, pl(c).x, pl(c).y)
      id = c
    End If
  Next c

  Return id

End Function

Function get_shortside_pl_to_pass (pl_id As Integer) As Integer

  Dim a(N_TOT_PL,2) As Integer
  Dim As Integer tile, c, id
  Dim max_dist As Integer = 10000
  '    'gets the ball's y and search the nearest pl to pass who is in the vert next tile
  '
  For c = 0 To N_TOT_PL * 2-1
    'don't pass himself or to a player of the other team
    If c = pl_id Or pl(c).team <> pl(pl_id).team Then Continue For
    If d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x+1,PITCH_MIDDLE_H) < max_dist Then
      max_dist = d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x+1,PITCH_MIDDLE_H)
      id = c
    End If
  Next c

  Return id

End Function


Function get_nrst2_pl_pass(pl_id As Integer, order As Integer) As Integer

  Dim a(N_TOT_PL,2) As Integer
  Dim As Integer b, c, lowest, start, change, ref
  'list all the pl's distances from the pl_id pl
  For c = 0 To N_TOT_PL * 2-1
    If c = pl_id Or pl(c).team <> pl(pl_id).team Then Continue For 'don't pass himself
    a(b,0)=c
    a(b,1)= d_b_t_p (pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y)

    b += 1
  Next c
  'sort'em using selection sorting algorithm
  For start = 0 To 9
    ref = a(start,1)
    change = 0
    For b = start+1 To 9
      If a(b,1) < ref Then
        ref = a(b, 1)
        lowest = b
        change = 1
      End If
    Next b
    If change Then
      Swap a(lowest, 0), a(start, 0)
      Swap a(lowest, 1), a(start, 1)
    End If
  Next start

  Return a(order, 0)

End Function

Function get_farrest_pl_to_pass(pl_id As Integer) As Integer
  Dim min_dist As Integer = 1
  Dim As Integer c, id, n_team
  n_team = pl(pl_id).team
  For c = 0 To N_TOT_PL * 2-1
    If c = pl_id Or pl(c).team <> n_team Then Continue For 'don't pass himself
    If d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y) > min_dist Then
      min_dist = d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y)
      id = c
    End If
  Next c

  Return id
End Function

Function get_centerest_pl_to_pass(pl_id As Integer) As Integer
  Dim max_dist As Integer = 10000
  Dim As Integer c, id

  For c = 0 To N_TOT_PL * 2-1
    If c = pl_id Or pl(c).team <> pl(pl_id).team Then Continue For 'don't pass himself
    If d_b_t_p(PITCH_MIDDLE_W,PITCH_MIDDLE_H,pl(c).x,pl(c).y) < max_dist Then
      max_dist = d_b_t_p(PITCH_MIDDLE_W,PITCH_MIDDLE_H,pl(c).x,pl(c).y)
      id = c
    End If
  Next c

  Return id
End Function

Function get_endline_pl_to_pass(pl_id As Integer) As Integer
  Dim max_dist As Integer = 10000
  Dim As Integer c, id, n_team
  n_team = pl(pl_id).team
  For c = 0 To N_TOT_PL * 2-1
    If c = pl_id Then Continue For 'don't pass himself
    If n_team <> pl(c).team Then Continue For 'don't pass to a player of other team
    If n_team = 1 Then
      If pl(c).x - (PITCH_X) < max_dist Then
        max_dist = pl(c).x - (PITCH_X)
        id = c
      End If
    Else
      If  max_dist > (PITCH_X + PITCH_W) - pl(c).x Then
        max_dist = (PITCH_X + PITCH_W) - pl(c).x
        id = c
      End If
    End If
  Next c

  Return id
End Function

Function get_ball_tile(team As Integer) As Integer
  Dim As Integer col, row, tile
  Dim As Integer x, y, x2,y2
  tile = 0
  'this routine find in which tile is the ball
  For row = 0 To ROW_TOT_N - 1 Step 1
    For col = COL_TOT_N - 1 To 0 Step -1
      'draw the grid
      x = row * PITCH_W \ ROW_TOT_N + PITCH_X
      y = col * PITCH_H \ COL_TOT_N + PITCH_Y
      x2 = x + PITCH_W \ ROW_TOT_N
      y2 = y + PITCH_H \ COL_TOT_N
      'check if the ball is into a tile of the grid
      If (ball.x > x) And (ball.x < x2) And (ball.y > y) And (ball.y < y2) Then
        Exit For, For
      End If
      tile +=1
    Next col
  Next row

  If team = 0 Then
    Return tile
  Else
    Return TILES_N_TOT - tile
  End If
End Function

Function get_passing_ball_speed (dist As Single) As Single
  Select Case Int(dist)
    Case 0 To 10
      Return 5.5f
    Case 11 To 30
      Return 8f
    Case 31 To 60
      Return 12f
    Case 61 To 100
      Return 18f
    Case Else
      Return 25f
  End Select
End Function

Function is_in_camera_crop (x As Single, y As Single, diam As Integer) As Integer
  If (x > camera.x - camera.w/2 - diam And x < (camera.x + camera.w/2 + diam))_
    And (y > camera.y - camera.y/2 - diam And y < (camera.y + camera.h/2 + diam)) Then
    Return 1
  Else
    Return 0
  End If
End Function


'GFX INIT--------------------------------------------------------------------------------
ScreenRes SCREEN_W,SCREEN_H,32,2,0 ' Sets the graphic mode
ScreenSet 1, 0
Width SCREEN_W\8,SCREEN_H\16 'set font width 16 pixel + cls
WindowTitle GAME_NAME + " " + Str(GAME_VERSION) + " by " + Str(GAME_AUTHOR)

'MAIN------------------------------------------------------------------------------------
load_tact()
load_behavior()
init_players_proprietes()
load_bitmap()
paint_kits(COLOR_YELLOW, COLOR_BLACK, COLOR_BLUE, COLOR_WHITE )'BVB Dortmund
ball_put_on_centre()
Do
  If Inkey = Chr(255,107) Then Exit Do 'if the user clicks the X button on the window then ... bye bye JASC
  get_user_input()
  check_pl_collisions()
  update_players()
  update_ball()
  ball_border_pitch_limit_check()
  camera_update_position()

  If PL_ball_owner_id >= 0 Then
    PL_ball_owner_delay -= 1
    If PL_ball_owner_delay <= 0 Then
      PL_ball_owner_delay = PL_DELAY_TIME*2
      PL_ball_owner_id = -1
    End If
  End If

  'graphic output
  ScreenLock ' Lock the screen
  ScreenSet workpage, workpage Xor 1 ' Swap work pages.
  Cls

  draw_pitch()
  draw_nets()

  If (DEBUG) Then
    'draw_grid()
    '        dim d as integer
    '        dim a as integer
    '        dim temp_String as String

    draw_grid()

    '        print "Goal 0: "; goal_team_0,"Goal 1: ";goal_team_1
    Print "ball tile 0: "; get_ball_tile(0)
    Print "ball tile 1: "; get_ball_tile(1)
    '        print "nearest team 0 id:"; get_nrst_pl_ball(0); " nr "; pl(get_nrst_pl_ball(0)).number, _
    '        "nearest team 1 id:"; get_nrst_pl_ball(1); " nr "; pl(get_nrst_pl_ball(1)).number
    '
    Print "ball.x  ball.y  speed rds z"
    Print Using "####.##"; ball.x, ball.y, ball.speed, ball.rds, ball.z

    '        print "     id   number    x     y    speed  rds delay  isincrop"
    '
    '        for d = 0 to N_TOT_PL * 2 - 1
    '            print using "####.##"; pl(d).id, pl(d).number, pl(d).x, pl(d).y, pl(d).speed,_
    '            pl(d).rds;pl(d).delay; is_in_camera_crop(pl(d).x, pl(d).y, 10),_
    '            get_tact_tile(d)
    '        next d
    '        print "PL_target_id ";PL_target_id
    '        print "PL_ball_owner_id ";PL_ball_owner_id
    '        print "MATCH_event ";MATCH_event
    '        'Debug
    '        for d = 0 to 9
    '            temp_string = ""
    '            for a = 0 to 35
    '                temp_string += str(tct_tile(d,a))
    '            next a
    '            draw string (0, 300 + (d*10)), temp_string
    '        next d

  End If

  draw_players()
  draw_ball()
  draw_bottom_info()

  workpage Xor = 1 ' Swap work pages.
  ScreenSync 'wait for vsync
  ScreenUnLock ' Unlock the page to display what has been drawn on the screen

  Sleep SLEEP_TIME, 1 ' Slow down the program to prevent CPU overheating :)

Loop Until MultiKey(SC_Q) Or MultiKey(SC_ESCAPE)

delete_bitmap()

End
